class PrintStreamBase: public std::ostream
{
public:
    virtual void DoSPC(int count);
    virtual void DoTAB(int count);
    virtual void DoNextTAB();
    virtual void DoCRLF();
};
class InputStreamBase: public std::istream
{
public:
    virtual void ReadLine(BAS_STR& target);
    template<typename T>
    virtual void InputTo(T& target);
    virtual bool Satisfied();
    static const char* GetRedoMsg() { return "\n?Redo from start;\n"; }
};

#define GET_STREAM_OUTPUT(filenumber_expr)
#define GET_PRINTER()
#define GET_STDOUT()
#define GET_STDIN()
#define GET_STREAM_INPUT(filenumber_expr)

class UsingFormatter
{
public:
    template<typename T>
    void DoParam(PrintStreamBase& out, const T& value);
    /* Note: DoParam() can execute B_ERROR(13) (Type mismatch) */
};
